function y = dst2(x)
%   Discrete sine transform.
%   x is a 2-d matrix of class double.
%   y is returned as a matrix of class double.
%   
narginchk(1,1);
validateattributes(x,{'double'},{'2d'});
[m, n] = size(x);
a = 1:m;
T1 = sqrt(2 / (m+1)) * sin(pi * (a)' *a/ (m+1));
a = 1:n;
T2 = sqrt(2 / (n+1)) * sin(pi * (a)' *a/ (n+1));
y = T1*x*T2';