function J = DCTfilter(varargin)
args = matlab.images.internal.stringToChar(varargin);
if nargin==0
    error(['Input image does not exist.']);
else
    I = args{1};
    if isempty(I)
        error('Input image is empty.');
    end
    if ~isfloat(I) || min(I(:)) < 0 || max(I(:)) > 1
        error('Input image I must be a double precision on the closed interval [0,1].');
    end
end
if nargin==1
    T = 0.3;
else
    T = args{2};
    if T<0 || T>1
        error('Threshold T must be on the closed interval [0,1].');
    end
end
B = 4;
J = I;
I = padarray(I,[B B],'symmetric','both');
[lgn,cln] = size(I);
for m=B+1:lgn-B
    for n=B+1:cln-B
        x = I(m-B:m+B-1,n-B:n+B-1);
        y = dct2(x);
        y0 = y(1,1);
        y(abs(y)<T) = 0;
        y(1,1) = y0;
        x = idct2(y);
        J(m-B,n-B) = x(B+1,B+1);
    end
end
J(J<0) = 0;
J(J>1) = 1;