function v = NoiseEstim(varargin)
% y = NoiseEstim(I,nhood)
args = matlab.images.internal.stringToChar(varargin);
if nargin==0
    error('Input image does not exist.');
elseif nargin==1
    nhood = true(5);
    I = args{1};
else
    nhood = args{2};
    I = args{1};
end
if isempty(I)
    error('Input image is empty.');
end
if ~isfloat(I) || min(I(:)) < 0 || max(I(:)) > 1
    error('Input image I must be a double precision on the closed interval [0,1].');
end
dias = stdfilt(I,nhood).^2;
x = dias(:);
xs = sort(x);
xm = xs(round(0.25*length(xs)):round(0.5*length(xs)));
par = polyfit(round(0.25*length(xs)):round(0.5*length(xs)),xm,1);
ith = find(xs'>1.1*(par(1)*(1:length(xs))+par(2)),1,'first');
v = mean(xs(1:ith));